<?xml version="1.0"?>
<ruleset xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" name="PSR-12" xsi:noNamespaceSchemaLocation="phpcs.xsd">
    <description>The coding standard for PHP_CodeSniffer itself.</description>

    <!-- Scan Folder Settings -->
    <file>oersi.php</file>
    <file>index.php</file>
    <file>inc/</file>
    <file>templates/</file>

    <exclude-pattern>*/.git/*</exclude-pattern>
    <exclude-pattern>*/.gitignore</exclude-pattern>
    <exclude-pattern>*/.gitmodules</exclude-pattern>
    <exclude-pattern>*/.DS_Store</exclude-pattern>
    <exclude-pattern>*/.idea/*</exclude-pattern>
    <exclude-pattern>*/.vscode/*</exclude-pattern>
    <exclude-pattern>*/packages/*</exclude-pattern>
    <exclude-pattern>*/vendor/*</exclude-pattern>
    <exclude-pattern>*/node_modules/*</exclude-pattern>
    <exclude-pattern>*/languages/*</exclude-pattern>
    <exclude-pattern>*/docs/*</exclude-pattern>
    <exclude-pattern>*/assets/*</exclude-pattern>
    <exclude-pattern>*/.phpdoc/*</exclude-pattern>
    <exclude-pattern>*/.bin/*</exclude-pattern>
    <exclude-pattern>*/husky/*</exclude-pattern>




    <!-- Default Settings -->
    <arg name="colors"/>
    <arg name="parallel" value="4"/>


    <!-- Apply Standard -->
    <rule ref="Generic.Arrays.ArrayIndent"/>
    <rule ref="Generic.Arrays.DisallowLongArraySyntax"/>
    <rule ref="Generic.ControlStructures.InlineControlStructure"/>
    <rule ref="Generic.Formatting.SpaceAfterCast"/>
    <rule ref="Generic.PHP.DeprecatedFunctions"/>
    <rule ref="Generic.PHP.Syntax"/>
    <rule ref="Generic.WhiteSpace.IncrementDecrementSpacing"/>
    <!-- Include some sniffs from other standards that don't conflict with PEAR -->
    <rule ref="Squiz.Arrays.ArrayBracketSpacing"/>
    <rule ref="Squiz.Arrays.ArrayDeclaration"/>
    <!-- <rule ref="Squiz.Commenting.ClosingDeclarationComment"/> -->
    <rule ref="Squiz.ControlStructures.ControlSignature"/>
    <!-- <rule ref="Squiz.ControlStructures.ElseIfDeclaration"/> -->
    <rule ref="Squiz.Commenting.BlockComment"/>
    <rule ref="Squiz.Commenting.DocCommentAlignment"/>
    <rule ref="Squiz.Commenting.EmptyCatchComment"/>
    <rule ref="Squiz.Commenting.InlineComment"/>
    <rule ref="Squiz.Commenting.LongConditionClosingComment"/>
    <rule ref="Squiz.Commenting.PostStatementComment"/>
    <rule ref="Squiz.Formatting.OperatorBracket"/>
    <rule ref="Squiz.Functions.FunctionDeclarationArgumentSpacing"/>
    <!-- <rule ref="Squiz.PHP.DisallowInlineIf"/> -->
    <rule ref="Squiz.Scope.MethodScope"/>
    <rule ref="Squiz.Strings.ConcatenationSpacing"/>
    <rule ref="Squiz.WhiteSpace.ControlStructureSpacing"/>
    <!-- <rule ref="Squiz.WhiteSpace.FunctionClosingBraceSpace"/> -->
    <rule ref="Squiz.WhiteSpace.FunctionSpacing"/>
    <rule ref="Squiz.WhiteSpace.MemberVarSpacing"/>
    <rule ref="Squiz.WhiteSpace.OperatorSpacing"/>
    <rule ref="Squiz.WhiteSpace.SuperfluousWhitespace"/>
    <rule ref="Generic.Commenting.Todo"/>
    <rule ref="Generic.ControlStructures.DisallowYodaConditions"/>
    <rule ref="Generic.Formatting.DisallowMultipleStatements"/>
    <!-- <rule ref="Generic.NamingConventions.ConstructorName"/> -->
    <rule ref="Generic.PHP.LowerCaseKeyword"/>
    <!-- <rule ref="Generic.Strings.UnnecessaryStringConcat"/> -->
    <rule ref="PSR2.Classes.PropertyDeclaration"/>
    <rule ref="PSR2.Methods.MethodDeclaration"/>
    <rule ref="PSR2.Files.EndFileNewline"/>
    <rule ref="PSR12.Files.OpenTag"/>
    <rule ref="Zend.Files.ClosingTag"/>

    <rule ref="PSR2">
        <exclude name="PSR1.Files.SideEffects"/>
        <exclude name="PSR1.Methods.CamelCapsMethodName"/>
        <exclude name="PSR1.Classes.ClassDeclaration.MissingNamespace"/>
        <exclude name="PSR2.Classes.ClassDeclaration.CloseBraceAfterBody"/>
        <exclude name="Squiz.ControlStructures.ElseIfDeclaration"/>
        <exclude name="Generic.Files.LineLength.TooLong"/>
        <exclude name="Generic.Files.LineEndings.InvalidEOLChar"/>
    </rule>


    <!-- Custom Rule or Threshold -->
    <!--
        lineLimit will show warnings
        absoulteLineLimit will show errors
    -->
    <!-- <rule ref="Generic.Files.LineLength">
        <properties>
            <property name="lineLimit" value="300"/>
        </properties>
    </rule> -->
    <!-- Private methods MUST not be prefixed with an underscore -->
    <rule ref="PSR2.Methods.MethodDeclaration.Underscore">
        <type>error</type>
    </rule>


    <!-- Check var names, but we don't want leading underscores for private vars -->
    <!-- <rule ref="Squiz.NamingConventions.ValidVariableName"/> -->
    <rule ref="Squiz.NamingConventions.ValidVariableName.PrivateNoUnderscore">
        <severity>0</severity>
    </rule>
    <!-- We use custom indent rules for arrays -->
    <rule ref="Generic.Arrays.ArrayIndent"/>
    <rule ref="Squiz.Arrays.ArrayDeclaration.KeyNotAligned">
        <severity>0</severity>
    </rule>
    <rule ref="Squiz.Arrays.ArrayDeclaration.ValueNotAligned">
        <severity>0</severity>
    </rule>
    <rule ref="Squiz.Arrays.ArrayDeclaration.CloseBraceNotAligned">
        <severity>0</severity>
    </rule>
    <rule ref="Squiz.Arrays.ArrayDeclaration.CloseBraceNewLine">
        <severity>0</severity>
    </rule>

    <!-- Private properties MUST not be prefixed with an underscore -->
    <rule ref="PSR2.Classes.PropertyDeclaration.Underscore">
        <type>error</type>
    </rule>
    <!-- <rule ref="Generic.Files.LineLength.MaxExceeded">
        <message>Line contains %s chars, which is longer than the max limit of %s</message>
    </rule>
    <rule ref="Generic.Files.LineLength.TooLong">
        <message>Line longer than %s characters; contains %s characters</message>
    </rule> -->
</ruleset>
